/****************************************************************************/
/*                                                                          */
/* ipp.c     preprocessor f|r att skapa menu.wd                             */
/*                                                                          */
/* 1985-08-19  Stig Bystr|m                                                 */
/****************************************************************************/

#include <signal.h>
#include <stdio.h>
#include <errno.h>
#include <sgtty.h>
#include <ctype.h>
#undef FIOCLEX
#undef FIONCLEX
#include <win/w_const.h>
#include <win/w_types.h>
#include <win/w_structs.h>
#include <win/w_macros.h>

#define STDIN 0
#define STDOUT 1
#define TRUE 1
#define FALSE 0
#define BUFSIZE 256
#define NAMESIZE 14

int i,x,y;
char inbuf[256];
struct sgttyb ttysave;  /* setraw/setcooked */
int errno;     /* getone */
char speed[4096];
int sptr;
char str[256];
int intflag;
int echoflag;
int cnt;        /* # of characters left in keybuf[]*/
int fd; /* filedescriptor f|r menu.wd */
int tmpfil; /* buffertfil f|r action terminal */
int menynrn; /* H}ll reda p} ledigt meny-nummer */
int winnr=1;  /* H}ll reda p} ledigt window-nummer */
int termnr=100; /* H}ll reda p} ledigt terminalnummer (ut p} tmpfil) */
char namebuf[15];
char grname[BUFSIZE];
char installname[BUFSIZE];
char *grbp,*grep,*inbp,*inep,*intp,*grn,*inn;
char buf[4096];

   /* Icon-positioner och -storlek */

/*1  2   3   4   5   6   7   8   9   10  11  12*/

short xporig[] = {
638,511,384,257,130,  3,638,511,384,257,130,  3,
638,511,384,257,130,  3,638,511,384,257,130,  3,
638,511,384,257,130,  3,638,511,384,257,130,  3};

short yporig[] = {
  3,  3,  3,  3,  3,  3, 64, 64, 64, 64, 64, 64,
125,125,125,125,125,125,186,186,186,186,186,186,
247,247,247,247,247,247,308,308,308,308,308,308};

short xlorig[] = {
  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,
130,130,130,130,130,130,130,130,130,130,130,130,
257,257,257,257,257,257,257,257,257,257,257,257};

short ylorig[] = {
  3, 64,125,186,247,308,369,430,491,552,613,674,
  3, 64,125,186,247,308,369,430,491,552,613,674,
  3, 64,125,186,247,308,369,430,491,552,613,674};

int xsize = 126;
int ysize =  60;


struct rectdes prekt[36]; /* w_structs.h  */
struct rectdes lrekt[36]; /* w_structs.h  */

main(argc,argv)
int argc;
char *argv[];
{
    int i,d;
    char cha[2];

    fd=creat("menu.wd",0777);
    tmpfil=creat("./installed/tmpfil_test.wd",0777);
    init();

    sendfill("#");
    sendfill("\n");
    sendfill("# Huvudmeny (meny1).");
    sendfill("\n");
    sendfill("#");
    sendfill("\n");
    sendfill("\n");
    menynrn=2;

    grn=grname;
    inn=installname;

    strcpy(grname,"./graphics/");
    strcpy(installname,"./installed/");

    grbp = grname + strlen(grname);
    inbp = installname + strlen(installname);

    namebuf[0]='I';
    namebuf[14]='\0';
    for(i=1;i<14;i++) namebuf[i]='0';
   
    d=bygg(1,1); /* bygg() returnerar 1 vid error */
    sendfill("\n");
    close(tmpfil);
    if(d==0) {
	cha[1]='\000';
	tmpfil=open("./installed/tmpfil_test.wd",0);
	while((i=read(tmpfil,&cha[0],1))>0)sendfill(cha);
	close(tmpfil);
	send();
    }
    close(fd);
    if(d==0){
	d=execl("/usr/window/bin/wshpp","wshpp","menu.wd",0);
    }
}
/******slut main*************************************************************/
   

/*******bygg*****************************************************************/
bygg(i,mnr) /* returnerar 1 vid error */
int i,mnr;
{
    int j,k,l,g;
    char action[36];
    int nr[36];
    char tmpbuf[9];
    int d;
    int plats;
    char plch;
    char ch;
    char icbuf[BUFSIZE];
    char *icp;
    int choice;
    int felflg;
    int felplats;
    int fe,ff; /* filedescriptorer */
    int tomflg;
    int wind=FALSE;
    int head=FALSE;
    int zoom=FALSE;
    int dire=FALSE;
    int wait=FALSE;
    int envi=FALSE;
    int comm=FALSE;

    g=0;
    for(j=0;j<36;j++){      /* G} igenom alla f{lt  */
        plats=j;
	if((plats>=0)&&(plats<=8)) plch=(plats+'1');
  	                      else plch=(plats-9+'a');
        namebuf[i]=plch;
        strcpy(inbp,namebuf);

	fe=open(installname,0);
	if(fe<0){
	    action[j]='m'; /* meny* ( ikon saknas ) */
	}
	else{
	    /* Kontroll av externtion */
	    icp=icbuf;
	    ch='a';/* a==dummy*/
	    while ((ch!=',')&&((d=read(fe,&ch,1))>0)){ /* L{s ikonsfilnamn */
	        *icp++=ch;
	    }
	    *--icp='\000';

	    l=extcheck(icbuf);
	    
	    if(l==0){
		action[j]='t'; /*terminal*/
		g=j; /* h}ll reda p} sista f{ltet med ikon */
	    }
	    else{
		action[j]='m'; /* [ndras till 'c' nedan om undermeny finns */
		for(k=0;k<36;k++){      /* G} igenom alla f{lt  */
		    plats=k;
		    if((plats>=0)&&(plats<=8)) plch=(plats+'1');
  	                                  else plch=(plats-9+'a');
	            namebuf[i+1]=plch;
		    strcpy(inbp,namebuf);
		    ff=open(installname,0);
		    if(ff>0){
			/* Granskad ikon {r far till undermeny */
			action[j]='c';   /* ny meny (under) */
		        g=j; /* h}ll reda p} sista f{ltet med ikon */
			k=36;
		    }
		    close(ff);
		}
	    }
	    namebuf[i+1]='0';
	}
	close(fe);
    }
    g++; /* r{kna upp g s} att g anger antalet ikoner */
    if(g<36){
	g++; /* g|r plats f|r logout eller tillbaka till meny1 */
	while(g%6!=0) g++;
	if(i==1) action[g-1]='l'; /* l = logout */
 	    else action[g-1]='k'; /* k = tillbaka till meny1 */
	felplats=g-1;
    }
    else{
	felflg=TRUE;
	for(l=0;l<36;l++){
	    if(action[l]=='m'){
		if(i==1) action[l]='l'; /* l = logout */
		    else action[l]='k'; /* k = tillbaka till meny1 */
                felplats=l;
		l=36;
		felflg=FALSE;
		continue;
	    }
        }
        if(felflg==TRUE){/* Fel ge felmeddelande och avbryt */
 	    printf("%36s","Det finns ej plats f|r avbrotts-ikon");
	    for(i=0;i<99999999999;i++) j=((i*2))/2;
	    return(1);
        }
    }
    printf("%d%36s%2s",mnr,action,"\n");
    sendfill("menu");
    numout(mnr);

    sendfill(":window");
    numout(g/6);
    sendfill(":pstring");
    numout(mnr);
    sendfill(":lstring");
    numout(mnr);
    choice=mnr*100;
    for(l=0;l<g;l++){
	sendfill(":choice");
	numout(choice);
	choice++;
    }
    sendfill("\n");
    sendfill("#");
    sendfill("\n");
    sendfill("pstring");
    numout(mnr);
    sendfill(":\\");
    sendfill("\n");
    sendfill("\\ec\\e[2J\\e[?35h\\e[0m\\\n");
    ramar(g,'p');
    for(l=0;l<g;l++){
	/* kopiera |ver esc-sekvenserna fr}n graphics till
           menu.wd  f|r varje ikon i menyn */
	sendfill("\\e[0m");
	sendfill("\\e:");
	numout(xporig[g-l-1]);
	sendfill(";");
	numout(yporig[g-l-1]);
	sendfill("O\\");
        sendfill("\n");
        sendfill("\\e(H");  /* S{tt font till H */
	if(l==felplats){
	    if(action[l]=='l')sendfill("\\e:18;23m\\e:1HUTLOGGNING");
		         else sendfill("\\e:22;23m\\e:1HHUVUDMENY");
	    sendfill("\\e[0m");
	    if((l+1)!=g) sendfill("\\");
	    sendfill("\n");
	}
	else{
	    if((action[l]=='t')||(action[l]=='c')){
		/* plocka fram grafikfilen */
		plats=l;
		if((plats>=0)&&(plats<=8)) plch=(plats+'1');
  	                              else plch=(plats-9+'a');
	        namebuf[i]=plch;
		Cgraphics();
	        sendfill("\\e[0m");
   	        if((l+1)!=g) sendfill("\\");
	        sendfill("\n");
		namebuf[i]='0';
	    }
	}
    }
    sendfill("\n");
    sendfill("#");
    sendfill("\n");
    sendfill("lstring");
    numout(mnr);
    sendfill(":\\");
    sendfill("\n");
    sendfill("\\ec\\e[2J\\e[?35h\\e[0m\\\n");
    ramar(g,'l');
    for(l=0;l<g;l++){
	/* kopiera |ver esc-sekvenserna fr}n graphics till
           menu.wd  f|r varje ikon i menyn */
	sendfill("\\e[0m");
	sendfill("\\e:");
	numout(xlorig[g-l-1]);
	sendfill(";");
	numout(ylorig[g-l-1]);
	sendfill("O\\");
        sendfill("\n");
        sendfill("\\e(H");  /* S{tt font till H */
	if(l==felplats){
	    if(action[l]=='l')sendfill("\\e:18;23m\\e:1HUTLOGGNING");
		         else sendfill("\\e:22;23m\\e:1HHUVUDMENY");
	    sendfill("\\e[0m");
	    if((l+1)!=g) sendfill("\\");
	    sendfill("\n");
	}
	else{
	    if((action[l]=='t')||(action[l]=='c')){
		/* plocka fram grafikfilen */
		plats=l;
		if((plats>=0)&&(plats<=8)) plch=(plats+'1');
  	                              else plch=(plats-9+'a');
	        namebuf[i]=plch;
		Cgraphics();
	        sendfill("\\e[0m");
		if((l+1)!=g) sendfill("\\");
		sendfill("\n");
		namebuf[i]='0';
	    }
	}
    }
    sendfill("\n");
    sendfill("#");
    sendfill("\n");
    choice=mnr*100;
    for(l=0;l<g;l++){
	sendfill("choice");
	numout(choice);
	sendfill(":icon");
	numout(g-l);
	sendfill(":action");
	numout(choice);
	sendfill("\n");
	choice++;
    }
    sendfill("#");
    sendfill("\n");
    choice=mnr*100;
    strcpy(tmpbuf,"terminal");/* L{ggs ut f|rst i varje "terminal" i tmpfil */
    for(l=0;l<g;l++){
	sendfill("action");
	numout(choice);
	choice++;
	switch(action[l]){
	        case 'm':
  	             sendfill(":menu");
	             numout(mnr);
	             sendfill("\n");
		break;

		case 'l':
		     sendfill(":logout:menu");
		     numout(mnr);
		     sendfill("\n");
		break;

		case 'k':
		     sendfill(":close:menu1");
		     sendfill("\n");
		break;

		case 't':
		     sendfill(":terminal");
		     numout(termnr);
		     d=write(tmpfil,tmpbuf,strlen(tmpbuf));/* terminalXXX: */
		     tmpnumout(termnr);
		     termnr=termnr+100;
		     sendfill(":menu");
		     numout(mnr);
		     sendfill("\n");
		     /* L{s ut kommandon p} tmpfil */
	             plats=l;
		     if((plats>=0)&&(plats<=8)) plch=(plats+'1');
    	                                   else plch=(plats-9+'a');
	             namebuf[i]=plch;
		     strcpy(inbp,namebuf);
		     fe=open(installname,0);
		     if(fe>0){
			 ch='a'; /* a dummyv{rde */
			 d=2;
			 /* L{s f|rbi /icons/filnamn*/
			 while((ch!=',')&&((d=read(fe,&ch,1))>0));
			 ch='a'; /* a dummyv{rde */
			 d=2;
			  /* L{s f|rbi grafikfilnamn */
			 while ((ch!=',')&&((d=read(fe,&ch,1))>0));

			 ch='a'; /* a dummyv{rde */
			 d=2;
			  /* L{s och Skriv window */
			 while ((ch!=',')&&((d=read(fe,&ch,1))>0)){
			     if(ch!=','){
				 wind=TRUE;
			     }
			 }
			 if(wind){
			     d=write(tmpfil,":window",7);
			     tmpnumout(termnr-100);
			 }
			 ch='a'; /* a dummyv{rde */
			 d=2;
			  /* L{s och Skriv header */
			 while ((ch!=',')&&((d=read(fe,&ch,1))>0)){
			     if(ch!=','){
				 head=TRUE;
			     }
			 }
			 if(head){
			     d=write(tmpfil,":header",7);
			     tmpnumout(termnr-100);
			 }
			 ch='a'; /* a dummyv{rde */
			 d=2;
			  /* L{s och Skriv zoomlist */
			 while ((ch!=',')&&((d=read(fe,&ch,1))>0)){
			     if(ch!=','){
				 zoom=TRUE;
			     }
			 }
			 if(zoom){
			     d=write(tmpfil,":zoomlist",9);
			     tmpnumout(termnr-100);
			 }
			 ch='a'; /* a dummyv{rde */
			 d=2;

			  /* L{s och Skriv directory */
			 while ((ch!=',')&&((d=read(fe,&ch,1))>0)){
			     if(ch!=','){
				 dire=TRUE;
			     }
			 }
			 if(dire){
			     d=write(tmpfil,":directory",10);
			     tmpnumout(termnr-100);
			 }
			 ch='a'; /* a dummyv{rde */
			 d=2;
			  /* L{s och Skriv wait */
			 while ((ch!=',')&&((d=read(fe,&ch,1))>0)){
			     if(ch!=','){
				 wait=TRUE;
			     }
			 }
			 if(wait){
			     d=write(tmpfil,":wait",5);
			 }
			 wait=FALSE;
			 ch='a'; /* a dummyv{rde */
			 d=2;
			  /* L{s och Skriv environ */
			 while ((ch!=',')&&((d=read(fe,&ch,1))>0)){
			     if(ch!=','){
				 envi=TRUE;
			     }
			 }
			 if(envi){
			     d=write(tmpfil,":environ",8);
			     tmpnumout(termnr-100);
			 }
			 ch='a'; /* a dummyv{rde */
			 d=2;
			  /* L{s och Skriv command */
			 while ((ch!=',')&&((d=read(fe,&ch,1))>0)){
			     if(ch!=','){
				 comm=TRUE;
			     }
			 }
			 if(comm){
			     d=write(tmpfil,":command",8);
			     tmpnumout(termnr-100);
			 }
			 d=write(tmpfil,"\n",2);

			 /* L{s kommando-sekvenserna till tmpfil) */
			 if(wind){
			     wind=FALSE;
			     d=write(tmpfil,"window",6);
			     tmpnumout(termnr-100);
			     ch='a'; /* a dummyv{rde */
 			     while ((ch!='$')&&((d=read(fe,&ch,1))>0)){
				 if(ch!='$'){
				     d=write(tmpfil,&ch,1);
				 }
			     }
			     d=write(tmpfil,"\n",2);
			 }
			 if(head){
			     head=FALSE;
			     d=write(tmpfil,"header",6);
			     tmpnumout(termnr-100);
			     ch='a'; /* a dummyv{rde */
 			     while ((ch!='$')&&((d=read(fe,&ch,1))>0)){
				 if(ch!='$'){
				     d=write(tmpfil,&ch,1);
				 }
			     }
			     d=write(tmpfil,"\n",2);
			 }
			 if(zoom){
			     zoom=FALSE;
			     d=write(tmpfil,"zoomlist",8);
			     tmpnumout(termnr-100);
			     ch='a'; /* a dummyv{rde */
 			     while ((ch!='$')&&((d=read(fe,&ch,1))>0)){
				 if(ch!='$'){
				     d=write(tmpfil,&ch,1);
				 }
			     }
			     d=write(tmpfil,"\n",2);
			 }
			 if(dire){
			     dire=FALSE;
			     d=write(tmpfil,"directory",9);
			     tmpnumout(termnr-100);
			     ch='a'; /* a dummyv{rde */
 			     while ((ch!='$')&&((d=read(fe,&ch,1))>0)){
				 if(ch!='$'){
				     d=write(tmpfil,&ch,1);
				 }
			     }
			     d=write(tmpfil,"\n",2);
			 }

			 if(envi){
			     envi=FALSE;
			     d=write(tmpfil,"environ",7);
			     tmpnumout(termnr-100);
			     ch='a'; /* a dummyv{rde */
 			     while ((ch!='$')&&((d=read(fe,&ch,1))>0)){
				 if(ch!='$'){
				     d=write(tmpfil,&ch,1);
				 }
			     }
			     d=write(tmpfil,"\n",2);
			 }
			 if(comm){
			     comm=FALSE;
			     d=write(tmpfil,"command",7);
			     tmpnumout(termnr-100);
			     ch='a'; /* a dummyv{rde */
 			     while ((ch!='$')&&((d=read(fe,&ch,1))>0)){
				 if(ch!='$'){
				     d=write(tmpfil,&ch,1);
				 }
			     }
			     d=write(tmpfil,"\n",2);
			 }
                     }
                     close(fe);
/*  	             namebuf[i]='0';*/
 	 	break;

		case 'c':
		     sendfill(":close:menu");
		     numout(menynrn);/* menynrn == n{sta lediga menynummer */
		     nr[l]=menynrn;
		     menynrn++;
	        break;
	} /*end switch */
        sendfill("\n");
    }
    d=0;
    for(j=0;j<36;j++){
	if(d==1) return(1);
        if(action[j]=='c'){
	    k=i+1;
            plats=j;
	    if((plats>=0)&&(plats<=8)) plch=(plats+'1');
  	                          else plch=(plats-9+'a');
            namebuf[i]=plch;
	    d=bygg(k,nr[j]);
	}
    }
    return(0);
}
/*****slut bygg()************************************************************/

/****************************************************************************/

/****************************************************************************/
sendfill(str)   /* fill speed-buffer with characters from str */
char str[];
{
        register i;

        i=0;

        while( str[i] != '\000' ){
	    speed[sptr] = str[i];
	    sptr++;
	    i++;
	}

	if( sptr>2000 ) send();
	return;
}
/****************************************************************************/
send()          /* flush buffer to file fd*/
{
    int d;

    d=write(fd,&speed[0],sptr);

    sptr = 0;
    return;
}

/************************************************************************/
numout(n)
register n;
{
        char cnvbuf[20];        /* conversion buffer    */
        register char *s;       /* pointer to cnvbuf[]  */

        s = &cnvbuf[20-1];
        *s = '\0';
        do {
                *--s = n % 10 + '0';
        } while ((n /= 10) > 0);
        sendfill(s);

        return;
}       /* end of numout        */

/************************************************************************/
tmpnumout(n)
register n;
{
        char cnvbuf[20];        /* conversion buffer    */
        register char *s;       /* pointer to cnvbuf[]  */
        int i;

        s = &cnvbuf[20-1];
        *s = '\0';
	i=0;
        do {
	    i++;
	    *--s = n % 10 + '0';
        } while ((n /= 10) > 0);
        write(tmpfil,s,i);

        return;
}       /* end of tmpnumout        */

/************************************************************************/
extcheck(buf)
char buf[NAMESIZE];
{
    int i,j,d;
    char ext[4];

    i=0;
    ext[3]='\000';
    while((buf[i]!='.')&&(i<NAMESIZE))i++;
    if(buf[i]=='.'){
	for(j=0;j<3;j++)ext[j]=buf[j+i+1];
	d=strcmp(ext,"nod");
        if(d==0)return(1);
    }
    return(0);
}
/************************************************************************/

/****************************************************************************/
/* end of ipp.c                                                             */
/****************************************************************************/
