/**********************************************************/
/*                                                        */
/* medef.h  Definitioner och konstanter till meny-editor  */
/*          f|r ABC-1600                                  */
/*                                                        */
/*   1985-10-07 Stig Bystr|m                              */
/**********************************************************/

#define DIRSIZE 14             /* Max length of directoryname          */
#define BUFSIZE 256            /*                                      */
#define NAMESIZE 14            /* Max length of filename               */
#define ANTFALT 36             /* Max number of choices in a menu      */
#define ANTEDFALT 36           /* Antal arbetsf{lt utom NYA IKONER i f|nster*/
#define ANTNYICON 24           /* Max number of new icons in NYA IKONER */
#define NULL 0
#define  STDIN     0
#define  STDOUT    1
#define  STDERROUT 2
#define  TRUE      1
#define  FALSE     0
#define  RUTDUMMY  ANTEDFALT+ANTNYICON+1
#define  GRARUT    ANTEDFALT+ANTNYICON+2
#define  SVARTRUT  ANTEDFALT+ANTNYICON+3
#define  WIDTH     126
#define  HEIGHT    60
#define  GLUGGPX    495
#define  GLUGGPY    776
#define  GLUGGLX    147
#define  GLUGGLY    19
#define  MPX1      360 
#define  MPY1      437
#define  MPX2      360
#define  MPY2      290
#define  MPX3      360
#define  MPY3      143
#define  MLX1      725
#define  MLY1      737
#define  MLX2      573
#define  MLY2      737
#define  MLX3      421
#define  MLY3      737

/***********************************************************************/
/* Datastrukturer                                                      */
/***********************************************************************/

typedef struct lank {
    char flyttflg;
    char iconf[NAMESIZE+1];
};

typedef struct arbfalt {
    char nummer[NAMESIZE+1];
    struct lank falt[ANTFALT];
};

typedef struct ring {
    char nod[NAMESIZE+1];
    struct ring *next;
};

typedef struct inne {
    char nod[NAMESIZE+1];
    int tomflg;
    struct inne *next;
    struct inne *fore;
};
/*  Slut p} definition-fil                                 */
/***********************************************************/
