/************************************************************************/
/*      mkicon.c

        Routines for making icons

        1985-08-17 Stig Bystr|m
*/
/************************************************************************/
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <win/w_const.h>
#include <win/w_types.h>
#include <win/w_structs.h>
#include <win/w_macros.h>
#undef FIOCLEX
#undef FIONCLEX
#include <sgtty.h>
#include <signal.h>
#include <errno.h>
#include "icdef.h"
#ifndef
#define SIZEBUF 4096
#endif

char *posi[]={
"pxor#","pyor#","pxsi#","pysi#","pvxo#","pvyo#","pvxs#","pvys#",
"lxor#","lyor#","lxsi#","lysi#","lvxo#","lvyo#","lvxs#","lvys#",
"colr#","bord#","tsig#","nsig#","rsig#","csig#"};

struct keyw{
    char windnr[5];
};
struct keyw item[22];
char pfnt,lfnt;
struct sgttyb ttysave;
char speed[4096];
int sptr;
int echoflag;
int cnt;        /* # of characters left in keybuf[]*/
int fa; /*window descriptor*/
int fw; /*window descriptor*/
int fwflg=FALSE;

int hscr = FALSE;
int vscr = FALSE;
int cbox = FALSE;
int sbox = FALSE;
int mbox = FALSE;
int zbox = FALSE;
int pmod = FALSE;
int lmod = FALSE;
int stxt = FALSE;
int sbmp = FALSE;
int lock = FALSE;
int novr = FALSE;
int ncur = FALSE;
int nmov = FALSE;
int alls = FALSE;
int spec = FALSE;
int kscr = FALSE;
int wscr = FALSE;
int amsp = FALSE;
int rltv = FALSE;
int ncpi = FALSE;
int ncpo = FALSE;
int text = FALSE;
int wgrp = FALSE;

char namn[23];
char grnamn[25];
char icbuffer[15];
char grbuffer[15];
char cobuffer[4096];

char name[10];
char grna[10];
char wind[10];
char head[10];
char zoom[10];
char dire[10];
char wait[10];
char envi[10];
char penv[10];
char lenv[10];
char comm[10];
char windbuffer[SIZEBUF];
char headbuffer[SIZEBUF];
char zoombuffer[SIZEBUF];
char direbuffer[SIZEBUF];
char envibuffer[SIZEBUF];
char penvbuffer[SIZEBUF];
char lenvbuffer[SIZEBUF];
char commbuffer[SIZEBUF];

char *wbbp,*wbep;

#ifndef
#define F0 I_PMODE+I_LMODE+I_INVERT+I_PRESS+I_RQST+I_LZERO
#define F1 I_PMODE+I_LMODE+I_PRESS+I_RQST+I_LZERO
#endif


struct winstruc bpw; /* F|nster som programmet k|rs i */
struct winstruc bpvhjg; /* F|nster f|r listning av mellan-resultat */
struct winstruc bpstring;/* standardf|nster som anv{nds av flera */
struct winstruc bpwind;
struct winstruc bphead;
struct winstruc bpzoom;
struct winstruc bpdire;
struct winstruc bpenvi;

struct headstruc hsvhjg; /* F|nster f|r listning av mellan-resultat */
struct headstruc hsstring;/* standardf|nster som anv{nds av flera */
struct headstruc hswind;
struct headstruc hshead;
struct headstruc hszoom;
struct headstruc hsdire;
struct headstruc hsenvi;

/************************************************************************/
/*                         D A T A      A R E A                         */

main(argc,argv)         /* If argc >1, assume VT100 text terminal,      */
int argc;               /* otherwise ABC1600-screen is assumed          */
char *argv[];           /* If used with window-handler,mouse is used    */

{
    char *np,*grp,*icbuf,*grbuf;
    char c;
    char cha;
    int ch;
    int ff,i,j,d;
    int tmp;
    char *ep;
    char buf[SIZEBUF];

    initwin();    
/*    fa=open("/win",2);
    d=Wincreat(fa,&bpw);
*/
    setraw();
    cls();
    
    if(w_reini()!=0){
	sendfill("window error.\n");
    }
    tmp=winini();
    if(tmp!=0){
        Rmicons(0);
	exit();
    }
loop1:;
    gcur(12,585);
    fill(755,681,1);
    send();

    initdata();

    icbuffer[14]='\000';
    grbuffer[14]='\000';

    strcpy(namn,"./icons/");
    np=namn+strlen(namn);

    strcpy(grnamn,"./graphics/");
    grp=grnamn+strlen(grnamn);

    sendfill("\033[?35l");    /* cursor on */
    sendfill("\033[?34h");    /* cursor blink */
    setcooked();                            /* remove raw mode      */

    do{
	gcur(12,665);
	fill(755,681,0);
	gcur(17,665);
	sendfill("Vad ska kommando-filen heta ? ");
	send();
        d=read(STDIN,buf,SIZEBUF);
        if(d==1){/*RETURN*/
	    ff=0;
	}
	else{/*EJ RETURN*/
	    if(d<NAMESIZE){
		buf[d-1]='\000';
		for(i=d;i<NAMESIZE;i++)buf[i]='\000';
	    }
	    else{
		buf[NAMESIZE-1]='\000';
	    }
	    strcpy(np,buf);
	    strcpy(icbuffer,buf);
	    /* Kolla om upptagen ? */
	    ff=open(namn,0);
	    close(ff);
	    gcur(12,635);
	    fill(755,650,0);
	    gcur(17,635);
	    send();
	    if(ff>=0){
		printf("%10s","Filnamnet ");
		d=write(STDOUT,buf,strlen(icbuffer));
		printf("%9s"," upptaget");
	    }
	}
    }while(ff>=0);
    strcpy(name,"namn");
    do{
	gcur(12,650);
	fill(755,665,0);
	gcur(17,650);
	sendfill("Vad heter grafikfilen ? ");
	send();
        d=read(STDIN,buf,SIZEBUF);
        if(d==1){/*RETURN*/
	    ff=0;
	}
	else{/*EJ RETURN*/
	    if(d<NAMESIZE){
		buf[d-1]='\000';
		for(i=d;i<NAMESIZE;i++)buf[i]='\000';
	    }
	    else{
		buf[NAMESIZE-1]='\000';
	    }
	    strcpy(grp,buf);
	    strcpy(grbuffer,buf);
	    /* Kolla om filen finns ? */
	    ff=open(grnamn,0);
	    close(ff);
    	    gcur(12,635);
	    fill(755,650,0);
	    gcur(17,635);
	    send();
	    if(ff<0){
	        printf("%6s","Filen ");
	        d=write(STDOUT,grbuffer,strlen(grbuffer));
	        printf("%35s"," finns ej i biblioteket ./graphics/");
   	    }
        }
    }while(ff<=0);
    strcpy(grna,"namn");
    gcur(12,585);
    fill(755,681,0);
    gcur(17,665);
    sendfill("Anv{nd iconerna f|r att skapa kommandon !!");
    gcur(17,650);
    sendfill("Avsluta med iconen KLAR.");
    setraw();
/****** MAIN COMMAND LOOP ***************************************************/

    for ( ; ; ) {                   /* start loop                   */
        sendfill("\033:8M");    /*8 set mouse mode: report on button*/
        echoflag = 0;

	sendfill("[?35h"); /* cursor off */
        c = getone();           /* get a character      */
        send();                 /* send to terminal     */
/*#####*/
        switch ( c ) {
            case 'A':/* window */
 	        send();
		fwflg=TRUE;
	        fw=open(WMNTDIR,2);  /* "/win" Skapa plats f|r f|nster */
		d=Wincreat(fw,&bpwind); /* Skapa f|nster */
		d=write(fw,"\n",2);
		d=write(fw,"Inmatning av f|nsterposition och storlek mm",43);
		d=write(fw,"\n",2);
		d=write(fw,"Ger du bara RETURN avbryts inmatningen",38);
		d=write(fw,"\n",2);
		d=write(fw,"Vill du hoppa |ver aktuell inmatning ge 0",41);
		d=write(fw,"\n",2);

		for(i=0;i<18;i++){
		    d=write(fw,posi[i],5);
		    d=read(fw,buf,SIZEBUF);

                   if(d==1){ /* RETURN */
			goto exit4;
		    }

		    if(d<5){
			for(j=d-1;j<4;j++) buf[j]='\0';
		    }
		    buf[4]='\0';

		    strcpy(item[i].windnr,buf);
		}
		d=write(fw,"\n",2);
		d=write(fw,"Inmatning av font-typ:\n",24);
		d=write(fw,"(A-Z) pfnt=",11);
		d=read(fw,buf,SIZEBUF);
		if(d==1){ /* RETURN */
		    goto exit4;
		}
		pfnt=buf[0];
		d=write(fw,"(A-Z) lfnt=",11);
		d=read(fw,buf,SIZEBUF);
		if(d==1){ /* RETURN */
		    goto exit4;
		}
		lfnt=buf[0];

		d=write(fw,"\n",2);
		d=write(fw,"Inmatning av signaler\n",23);
		d=write(fw,"\n",2);
		d=write(fw,"Ger du bara RETURN avbryts inmatningen",38);
		d=write(fw,"\n",2);
		d=write(fw,"Ge 0 om du inte vill ha den signalen\n",38);
		d=write(fw,"\n",2);
		for(i=18;i<22;i++){
		    d=write(fw,posi[i],5);
		    d=read(fw,buf,SIZEBUF);

                    if(d==1){ /* RETURN */
		        goto exit4;
		    }

		    if(d<5){
			for(j=d-1;j<4;j++) buf[j]='\0';
		    }
		    buf[4]='\0';

		    strcpy(item[i].windnr,buf);
		}

		cls();
		setfwraw();
		sendfw();
		d=fwwinini();
		if(d!=0){
		    goto exit4;
		}

		for ( ; ; ) {                   /* start loop */
	  	    sendfill("\033:8M");/*8 set mouse mode: report on button*/
		    echoflag = 0;

		    sendfill("[?35h"); /* cursor off */
		    c = getfw();           /* get a character      */
		    sendfw();                 /* send to terminal     */
/*#####*/
                    switch ( c ) {
			case 'A':/*  */
			    if(hscr==FALSE){
				hscr=TRUE;
				rut(0,1);
			    }
			    else{
				hscr=FALSE;
				rut(0,0);
			    }
			break;

                        case 'B':/*  */
			    if(vscr==FALSE){
				vscr=TRUE;
				rut(1,1);
			    }
			    else{
				vscr=FALSE;
				rut(1,0);
			    }
          	        break;

                        case 'C':/*  */
			    if(cbox==FALSE){
				cbox=TRUE;
				rut(2,1);
			    }
			    else{
				cbox=FALSE;
				rut(2,0);
			    }
                        break;

		        case 'D':/*  */
			    if(sbox==FALSE){
				sbox=TRUE;
				rut(3,1);
			    }
			    else{
				sbox=FALSE;
				rut(3,0);
			    }
                	break;

			case 'E':/*  */
			    if(mbox==FALSE){
				mbox=TRUE;
				rut(4,1);
			    }
			    else{
				mbox=FALSE;
				rut(4,0);
			    }
			break;

                        case 'F':/*  */
			    if(zbox==FALSE){
				zbox=TRUE;
				rut(5,1);
			    }
			    else{
				zbox=FALSE;
				rut(5,0);
			    }
          	        break;

                        case 'G':/*  */
			    if(pmod==FALSE){
				pmod=TRUE;
				rut(6,1);
			    }
			    else{
				pmod=FALSE;
				rut(6,0);
			    }
                        break;

		        case 'H':/*  */
			    if(lmod==FALSE){
				lmod=TRUE;
				rut(7,1);
			    }
			    else{
				lmod=FALSE;
				rut(7,0);
			    }
                	break;

			case 'I':/*  */
			    if(stxt==FALSE){
				stxt=TRUE;
				rut(8,1);
			    }
			    else{
				stxt=FALSE;
				rut(8,0);
			    }
			break;

                        case 'J':/*  */
			    if(sbmp==FALSE){
				sbmp=TRUE;
				rut(9,1);
			    }
			    else{
				sbmp=FALSE;
				rut(9,0);
			    }
          	        break;

                        case 'K':/*  */
			    if(lock==FALSE){
				lock=TRUE;
				rut(10,1);
			    }
			    else{
				lock=FALSE;
				rut(10,0);
			    }
                        break;

		        case 'L':/*  */
			    if(novr==FALSE){
				novr=TRUE;
				rut(11,1);
			    }
			    else{
				novr=FALSE;
				rut(11,0);
			    }
                	break;

			case 'M':/*  */
			    if(ncur==FALSE){
				ncur=TRUE;
				rut(12,1);
			    }
			    else{
				ncur=FALSE;
				rut(12,0);
			    }
			break;

                        case 'N':/*  */
			    if(nmov==FALSE){
				nmov=TRUE;
				rut(13,1);
			    }
			    else{
				nmov=FALSE;
				rut(13,0);
			    }
          	        break;

                        case 'O':/*  */
			    if(alls==FALSE){
				alls=TRUE;
				rut(14,1);
			    }
			    else{
				alls=FALSE;
				rut(14,0);
			    }
                        break;

		        case 'P':/*  */
			    if(spec==FALSE){
				spec=TRUE;
				rut(15,1);
			    }
			    else{
				spec=FALSE;
				rut(15,0);
			    }
                	break;

			case 'R':/*  */
			    if(kscr==FALSE){
				kscr=TRUE;
				rut(16,1);
			    }
			    else{
				kscr=FALSE;
				rut(16,0);
			    }
			break;

                        case 'S':/*  */
			    if(wscr==FALSE){
				wscr=TRUE;
				rut(17,1);
			    }
			    else{
				wscr=FALSE;
				rut(17,0);
			    }
          	        break;

                        case 'T':/*  */
			    if(amsp==FALSE){
				amsp=TRUE;
				rut(18,1);
			    }
			    else{
				amsp=FALSE;
				rut(18,0);
			    }
                        break;

		        case 'U':/*  */
			    if(rltv==FALSE){
				rltv=TRUE;
				rut(19,1);
			    }
			    else{
				rltv=FALSE;
				rut(19,0);
			    }
                	break;

			case 'V':/*  */
			    if(ncpi==FALSE){
				ncpi=TRUE;
				rut(20,1);
			    }
			    else{
				ncpi=FALSE;
				rut(20,0);
			    }
			break;

                        case 'W':/*  */
			    if(ncpo==FALSE){
				ncpo=TRUE;
				rut(21,1);
			    }
			    else{
				ncpo=FALSE;
				rut(21,0);
			    }
          	        break;

                        case 'X':/*  */
			    if(text==FALSE){
				text=TRUE;
				rut(22,1);
			    }
			    else{
				text=FALSE;
				rut(22,0);
			    }
                        break;

		        case 'Y':/*  */
			    if(wgrp==FALSE){
				wgrp=TRUE;
				rut(23,1);
			    }
			    else{
				wgrp=FALSE;
				rut(23,0);
			    }
                	break;

			case 'Z':/* KLAR */
			    goto exit3;
			break;

                        case 'Q':/*AVBRYT */
			    goto exit4;
                        break;

   	                case '\033':
		            cnt=0;    /*clear keybuf    */
     	                break;
                    };       /* end of switch        */
                } /* end for(;;){.... */

exit3:;
 	        strcpy(wind,"window");
		wbep=windbuffer;
                for(i=0;i<8;i++){
 	 	    *wbep++=':';
		    strcpy(wbep,posi[i]);
		    wbep=windbuffer+strlen(windbuffer);
		    strcpy(wbep,item[i].windnr);
		    wbep=windbuffer+strlen(windbuffer);
		}
                strcpy(wbep,":\\");
		wbep=windbuffer+strlen(windbuffer);
		*wbep++='\n';

		for(i=8;i<16;i++){
 	 	    *wbep++=':';
		    strcpy(wbep,posi[i]);
		    wbep=windbuffer+strlen(windbuffer);
		    strcpy(wbep,item[i].windnr);
		    wbep=windbuffer+strlen(windbuffer);
		}
                strcpy(wbep,":\\");
		wbep=windbuffer+strlen(windbuffer);
		*wbep++='\n';

		for(i=16;i<22;i++){
 	 	    *wbep++=':';
		    strcpy(wbep,posi[i]);
		    wbep=windbuffer+strlen(windbuffer);
		    strcpy(wbep,item[i].windnr);
		    wbep=windbuffer+strlen(windbuffer);
		}
                strcpy(wbep,":pfnt#");
		wbep=windbuffer+strlen(windbuffer);
		*wbep++='0';
		*wbep++='x';
		d=pfnt;
		windnumout(d-24,wbep);
		wbep=windbuffer+strlen(windbuffer);
                strcpy(wbep,":lfnt#");
		wbep=windbuffer+strlen(windbuffer);
		*wbep++='0';
		*wbep++='x';
		d=lfnt;
		windnumout(d-24,wbep);
		wbep=windbuffer+strlen(windbuffer);
                strcpy(wbep,":\\");
		wbep=windbuffer+strlen(windbuffer);
		*wbep++='\n';
		if(hscr==TRUE){
		    strcpy(wbep,":hscr");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(vscr==TRUE){
		    strcpy(wbep,":vscr");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(cbox==TRUE){
		    strcpy(wbep,":cbox");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(sbox==TRUE){
		    strcpy(wbep,":sbox");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(mbox==TRUE){
		    strcpy(wbep,":mbox");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(zbox==TRUE){
		    strcpy(wbep,":zbox");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(stxt==TRUE){
		    strcpy(wbep,":stxt");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(sbmp==TRUE){
		    strcpy(wbep,":sbmp");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(lock==TRUE){
		    strcpy(wbep,":lock");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(novr==TRUE){
		    strcpy(wbep,":novr");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(ncur==TRUE){
		    strcpy(wbep,":ncur");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(nmov==TRUE){
		    strcpy(wbep,":nmov");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(alls==TRUE){
		    strcpy(wbep,":alls");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(spec==TRUE){
		    strcpy(wbep,":spec");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(kscr==TRUE){
		    strcpy(wbep,":kscr");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(wscr==TRUE){
		    strcpy(wbep,":wscr");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(amsp==TRUE){
		    strcpy(wbep,":amsp");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(rltv==TRUE){
		    strcpy(wbep,":rltv");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(ncpi==TRUE){
		    strcpy(wbep,":ncpi");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(ncpo==TRUE){
		    strcpy(wbep,":ncpo");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(text==TRUE){
		    strcpy(wbep,":text");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(wgrp==TRUE){
		    strcpy(wbep,":wgrp");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(pmod==TRUE){
		    strcpy(wbep,":pmod");
		    wbep=windbuffer+strlen(windbuffer);
		}
		if(lmod==TRUE){
		    strcpy(wbep,":lmod");
		    wbep=windbuffer+strlen(windbuffer);
		}
		strcpy(wbep,"\000");

exit4:;
                Rmicons(fw);
		close(fw);
		fwflg=FALSE;
		initwin();
  	    break;

            case 'B':/* header */
	        fwflg=TRUE;
                fw=open(WMNTDIR,2);  /* "/win" Skapa plats f|r f|nster */
		d=Wincreat(fw,&bpstring); /* Skapa f|nster */
		d=Winheader(fw,&hshead);
                d=write(fw,"Ge header str{ngen:",19);
		d=read(fw,buf,SIZEBUF);
		buf[d]='\0';
		if(d!=1){ /*Ej RETURN*/
		    strcpy(head,"header");
		    wbep=headbuffer+strlen(headbuffer);
		    *wbep++=':';
		    strcpy(wbep,buf);
		}
		wbep=headbuffer+strlen(headbuffer);
		strcpy(wbep,"\000");

		close(fw);
		fwflg=FALSE;
		initwin();
	    break;

            case 'C':/* zoomlist */
	        fwflg=TRUE;
                fw=open(WMNTDIR,2);  /* "/win" Skapa plats f|r f|nster */
		d=Wincreat(fw,&bpstring); /* Skapa f|nster */
		d=Winheader(fw,&hszoom);
                d=write(fw,"Ge zoomlist str{ngen:",21);
		d=read(fw,buf,SIZEBUF);
		buf[d]='\0';
		if(d!=1){ /*Ej RETURN*/
		    strcpy(zoom,"zoomlist");
		    wbep=zoombuffer+strlen(zoombuffer);
		    *wbep++=':';
		    strcpy(wbep,buf);
		}
		wbep=zoombuffer+strlen(zoombuffer);
		strcpy(wbep,"\000");
		close(fw);
		fwflg=FALSE;
		initwin();
            break;

            case 'D':/* pointer */
	        /* Ej Implementerat */
  	    break;

            case 'E':/* icon */
	        /* Ej Implementerat */
            break;

            case 'F':/* string */
	        /* Ej Implementerat */
            break;

            case 'G':/* directory */
                fw=open(WMNTDIR,2);  /* "/win" Skapa plats f|r f|nster */
		d=Wincreat(fw,&bpstring); /* Skapa f|nster */
                d=write(fw,"Specifiera directory namn\n",27);
		d=write(fw,"tex. /usr/sven\n",16);
		d=read(fw,buf,SIZEBUF);
		buf[d]='\0';
		if(d!=1){ /*Ej RETURN*/
		    strcpy(dire,"directory");
		    wbep=direbuffer+strlen(direbuffer);
		    *wbep++=':';
		    strcpy(wbep,buf);
		}
		wbep=direbuffer+strlen(direbuffer);
		strcpy(wbep,"\000");
		close(fw);
		initwin();
            break;

            case 'H':/* super */
	        /* Ej Implementerat */
            break;     

            case 'I':/* wait */
	        strcpy(wait,"wait");
            break;

            case 'J':/* environ */
	        fwflg=TRUE;
                fw=open(WMNTDIR,2);  /* "/win" Skapa plats f|r f|nster */
		d=Wincreat(fw,&bpstring); /* Skapa f|nster */
		d=Winheader(fw,&hsenvi);
                d=write(fw,"Ge environ str{ngen:",21);
		d=read(fw,buf,SIZEBUF);
		buf[d]='\0';
		if(d!=1){ /*Ej RETURN*/
		    strcpy(envi,"environ");
		    wbep=envibuffer+strlen(envibuffer);
		    *wbep++=':';
		    strcpy(wbep,buf);
		}
		wbep=envibuffer+strlen(envibuffer);
		strcpy(wbep,"\000");
		close(fw);
		fwflg=FALSE;
		initwin();

            break;

            case 'K':/* command */
                fw=open(WMNTDIR,2);  /* "/win" Skapa plats f|r f|nster */
		d=Wincreat(fw,&bpstring); /* Skapa f|nster */
                d=write(fw,"Ge kommando str{ngen:",21);
		d=read(fw,buf,SIZEBUF);
		buf[d]='\0';
		if(d!=1){ /*Ej RETURN*/
		    strcpy(comm,"command");
		    wbep=commbuffer+strlen(commbuffer);
		    *wbep++=':';
		    strcpy(wbep,buf);
		}
		wbep=commbuffer+strlen(commbuffer);
		strcpy(wbep,"\000");
		close(fw);
		initwin();
            break;

            case 'L':
                     /*KLAR*/
		     goto exit1; /*Avsluta programet*/
            break;

            case 'M':
	            /* OMSTART */
		    goto loop1;
	    break;

            case 'N':
                     /*AVBRYT*/
		     goto exit2; /*Avsluta programet*/
	    break;

            case 'O':
                     /*VAD HAR JAG GJORT*/
                fw=open(WMNTDIR,2);  /* "/win" Skapa plats f|r f|nster */
		d=Wincreat(fw,&bpvhjg); /* Skapa f|nster */
		d=Winheader(fw,&hsvhjg);
		/* Skriv ut data i f|nstret */
		d=write(fw,"            Detta {r inmatat :          ",40);
		d=write(fw,"\n",1);
		d=write(fw,"\n",1);

		if((d=strcmp(name,"namn"))==0){
		    d=write(fw,"Kommandofilnamn: ",17);
		    d=write(fw,icbuffer,strlen(icbuffer));
		    d=write(fw,"\n",1);
		}
		if((d=strcmp(grna,"namn"))==0){
		    d=write(fw,"Grafikfilnamn: ",15);
		    d=write(fw,grbuffer,strlen(grbuffer));
		    d=write(fw,"\n",1);
		}
		if((d=strcmp(wind,"window"))==0){
		    d=write(fw,"window  ",8);
		    d=write(fw,windbuffer,strlen(windbuffer));
		    d=write(fw,"\n",1);
		}
		if((d=strcmp(head,"header"))==0){
		    d=write(fw,"header  ",8);
		    d=write(fw,headbuffer,strlen(headbuffer));
		    d=write(fw,"\n",1);
		}
		if((d=strcmp(zoom,"zoomlist"))==0){
		    d=write(fw,"zoomlist  ",10);
		    d=write(fw,zoombuffer,strlen(zoombuffer));
		    d=write(fw,"\n",1);
		}
		if((d=strcmp(dire,"directory"))==0){
		    d=write(fw,"directory  ",11);
		    d=write(fw,direbuffer,strlen(direbuffer));
		}
		if((d=strcmp(wait,"wait"))==0){
		    d=write(fw,"wait",4);
		    d=write(fw,"\n",1);
		}
		if((d=strcmp(envi,"environ"))==0){
		    d=write(fw,"environ  ",9);
		    d=write(fw,envibuffer,strlen(envibuffer));
		    d=write(fw,"\n",1);
		}
		if((d=strcmp(penv,"penviron"))==0){
		    d=write(fw,"penviron  ",10);
		    d=write(fw,penvbuffer,strlen(penvbuffer));
		    d=write(fw,"\n",1);
		}
		if((d=strcmp(lenv,"lenviron"))==0){
		    d=write(fw,"lenviron  ",10);
		    d=write(fw,lenvbuffer,strlen(lenvbuffer));
		    d=write(fw,"\n",1);
		}
		if((d=strcmp(comm,"command"))==0){
		    d=write(fw,"command  ",9);
		    d=write(fw,commbuffer,strlen(commbuffer));
		    d=write(fw,"\n",1);
		}
		d=write(fw,"\n\n",2);
		d=write(fw,"Tryck p} RETURN n{r du l{st f{rdigt",35);
		d=read(fw,buf,SIZEBUF);
		close(fw);
		initwin();
	    break;                        

  	    case '\033':
		     cnt=0;    /*clear keybuf    */
	    break;
        };       /* end of switch        */
    } /* end for(;;){.... */

exit1:utpfil();

exit2:;
    Rmicons(0);                             /* remove icons         */
    setcooked();                            /* remove raw mode      */
    sendfill("\033[?35l");                  /* cursor on            */
    cls();                                  /* clear screen         */
    send();                                 /* flush buffer         */
/*    close(fa);                              /* close window         */
}       /* main */
/****************************************************************************/

/****************************************************************************/
/* end of mkicon.c */
/****************************************************************************/
