/************************************************************************/
/*      mksub.c

        Rutiner till mkicon.c

        1985-08-17 Stig Bystr|m
*/
/************************************************************************/
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <win/w_const.h>
#include <win/w_types.h>
#include <win/w_structs.h>
#include <win/w_macros.h>
#undef FIOCLEX
#undef FIONCLEX
#include <sgtty.h>
#include <signal.h>
#include <errno.h>
#include "icdef.h"
#ifndef
#define SIZEBUF 4096
#endif

struct sgttyb ttysave;
int fd; /* filedescriptor */
extern char namn[23];
extern char icbuffer[15];
extern char grbuffer[15];

extern char name[10];
extern char grna[10];
extern char wind[10];
extern char head[10];
extern char zoom[10];
extern char dire[10];
extern char wait[10];
extern char envi[10];
extern char penv[10];
extern char lenv[10];
extern char comm[10];
extern char windbuffer[SIZEBUF];
extern char headbuffer[SIZEBUF];
extern char zoombuffer[SIZEBUF];
extern char direbuffer[SIZEBUF];
extern char envibuffer[SIZEBUF];
extern char penvbuffer[SIZEBUF];
extern char lenvbuffer[SIZEBUF];
extern char commbuffer[SIZEBUF];

extern struct winstruc bpw; /* F|nster som programmet k|rs i */
extern struct winstruc bpvhjg; /* F|nster f|r listning av mellan-resultat */
extern struct winstruc bpstring;/* standardf|nster som anv{nds av flera */
extern struct winstruc bpwind;
extern struct winstruc bphead;
extern struct winstruc bpzoom;
extern struct winstruc bpdire;
extern struct winstruc bpenvi;

extern struct headstruc hsvhjg; /* F|nster f|r listning av mellan-resultat */
extern struct headstruc hsstring;/* standardf|nster som anv{nds av flera */
extern struct headstruc hswind;
extern struct headstruc hshead;
extern struct headstruc hszoom;
extern struct headstruc hsdire;
extern struct headstruc hsenvi;
/****************************************************************************/
utpfil()
{
    fd=creat(namn,0777);
    write(fd,icbuffer,strlen(icbuffer));
    write(fd,",",1);
    write(fd,grbuffer,strlen(grbuffer));
    write(fd,",",1);
    write(fd,wind,strlen(wind));
    write(fd,",",1);
    write(fd,head,strlen(head));
    write(fd,",",1);
    write(fd,zoom,strlen(zoom));
    write(fd,",",1);
    write(fd,dire,strlen(dire));
    write(fd,",",1);
    write(fd,wait,strlen(wait));
    write(fd,",",1);
    write(fd,envi,strlen(envi));
    write(fd,",",1);
    write(fd,comm,strlen(comm));
    write(fd,",",1);

    if(strcmp(wind,"window")==0){
	write(fd,windbuffer,strlen(windbuffer));
	write(fd,"$",1);
    }
    if(strcmp(head,"header")==0){
	write(fd,headbuffer,strlen(headbuffer));
        write(fd,"$",1);
    }
    if(strcmp(zoom,"zoomlist")==0){
	write(fd,zoombuffer,strlen(zoombuffer));
	write(fd,"$",1);
    }
    if(strcmp(dire,"directory")==0){
	write(fd,direbuffer,strlen(direbuffer));
	write(fd,"$",1);
    }
    if(strcmp(envi,"environ")==0){
	write(fd,envibuffer,strlen(envibuffer));
	write(fd,"$",1);
    }
    if(strcmp(comm,"command")==0){
	write(fd,commbuffer,strlen(commbuffer));
	write(fd,"$",1);
    }
    
    close(fd);
    return;
}
/****************************************************************************/
initdata()
{
	name[0]='\000';
	grna[0]='\000';
	wind[0]='\000';
	head[0]='\000';
	zoom[0]='\000';
	dire[0]='\000';
	wait[0]='\000';
	envi[0]='\000';
	penv[0]='\000';
	lenv[0]='\000';
	comm[0]='\000';

    windbuffer[0]='\000';
    headbuffer[0]='\000';
    zoombuffer[0]='\000';
    direbuffer[0]='\000';
    envibuffer[0]='\000';
    penvbuffer[0]='\000';
    lenvbuffer[0]='\000';
    commbuffer[0]='\000';
    return;
}
/****************************************************************************/
initwin() /* initiering av f|nster */
{
    bpw.wp_xorig=0;
    bpw.wp_yorig=0;
    bpw.wl_xorig=0;
    bpw.wl_yorig=0;
    bpw.wp_xsize=768;
    bpw.wp_ysize=768;
    bpw.wl_xsize=768;
    bpw.wl_ysize=768;
    bpw.wp_vxorig=0;
    bpw.wp_vyorig=0;
    bpw.wl_vxorig=0;
    bpw.wl_vyorig=0;
    bpw.wp_vxsize=768;
    bpw.wp_vysize=768;
    bpw.wl_vxsize=768;
    bpw.wl_vysize=768;
    bpw.w_color=0;
    bpw.w_border=NOBORDER;
    bpw.wp_font='H';
    bpw.wl_font='H';
    bpw.w_tsig=0;
    bpw.w_ntsig=0;
    bpw.w_rsig=1;
    bpw.w_csig=0;
    bpw.w_flags=PMODE+LMODE+NOMOVE+NOCPIN+NOCPOUT;

    bpvhjg.wp_xorig=30;
    bpvhjg.wp_yorig=30;
    bpvhjg.wl_xorig=30;
    bpvhjg.wl_yorig=30;
    bpvhjg.wp_xsize=702;
    bpvhjg.wp_ysize=702;
    bpvhjg.wl_xsize=702;
    bpvhjg.wl_ysize=702;
    bpvhjg.wp_vxorig=1;
    bpvhjg.wp_vyorig=1;
    bpvhjg.wl_vxorig=1;
    bpvhjg.wl_vyorig=1;
    bpvhjg.wp_vxsize=700;
    bpvhjg.wp_vysize=700;
    bpvhjg.wl_vxsize=700;
    bpvhjg.wl_vysize=700;
    bpvhjg.w_color=1;
    bpvhjg.w_border=DLBORDER;
    bpvhjg.wp_font='H';
    bpvhjg.wl_font='H';
    bpvhjg.w_tsig=0;
    bpvhjg.w_ntsig=0;
    bpvhjg.w_rsig=1;
    bpvhjg.w_csig=0;
    bpvhjg.w_flags=PMODE+LMODE+NOMOVE+NOCPIN+NOCPOUT;

    bpstring.wp_xorig=12;
    bpstring.wp_yorig=585;
    bpstring.wl_xorig=12;
    bpstring.wl_yorig=585;
    bpstring.wp_xsize=744;
    bpstring.wp_ysize=97;
    bpstring.wl_xsize=744;
    bpstring.wl_ysize=97;
    bpstring.wp_vxorig=0;
    bpstring.wp_vyorig=0;
    bpstring.wl_vxorig=0;
    bpstring.wl_vyorig=0;
    bpstring.wp_vxsize=744;
    bpstring.wp_vysize=97;
    bpstring.wl_vxsize=744;
    bpstring.wl_vysize=97;
    bpstring.w_color=1;
    bpstring.w_border=NOBORDER;
    bpstring.wp_font='H';
    bpstring.wl_font='H';
    bpstring.w_tsig=0;
    bpstring.w_ntsig=0;
    bpstring.w_rsig=1;
    bpstring.w_csig=0;
    bpstring.w_flags=PMODE+LMODE+NOMOVE+KEYSCROLL+WRITSCROLL+NOCPIN+NOCPOUT;

    bpwind.wp_xorig=0;
    bpwind.wp_yorig=0;
    bpwind.wl_xorig=0;
    bpwind.wl_yorig=0;
    bpwind.wp_xsize=768;
    bpwind.wp_ysize=768;
    bpwind.wl_xsize=768;
    bpwind.wl_ysize=768;
    bpwind.wp_vxorig=0;
    bpwind.wp_vyorig=0;
    bpwind.wl_vxorig=0;
    bpwind.wl_vyorig=0;
    bpwind.wp_vxsize=768;
    bpwind.wp_vysize=768;
    bpwind.wl_vxsize=768;
    bpwind.wl_vysize=768;
    bpwind.w_color=0;
    bpwind.w_border=NOBORDER;
    bpwind.wp_font='H';
    bpwind.wl_font='H';
    bpwind.w_tsig=0;
    bpwind.w_ntsig=0;
    bpwind.w_rsig=0;
    bpwind.w_csig=0;
    bpwind.w_flags=PMODE+LMODE+NOMOVE+KEYSCROLL+WRITSCROLL+NOCPIN+NOCPOUT;

    strcpy(hsvhjg.h_hdr,"VAD [R GJORT ??");
    hsvhjg.h_flags=H_INVHD;

    strcpy(hswind.h_hdr,"WINDOW (Definiering av f|nster)");
    hswind.h_flags=H_INVHD;

    strcpy(hshead.h_hdr,"HEADER (Rubrik |ver f|nstret)");
    hshead.h_flags=H_INVHD;

    strcpy(hszoom.h_hdr,"ZOOMLIST (Icon f|r att {ndra f|nster storleken)");
    hszoom.h_flags=H_INVHD;

    strcpy(hsenvi.h_hdr,"ENVIRON (Milj|)");
    hsenvi.h_flags=H_INVHD;

    return;
}
/****************************************************************************/
/* end of mksub.c */
/****************************************************************************/
