/****************************************************************************/
/*                                                                          */
/* igr.c   tillh|r preprocessor f|r att skapa menu.wd                       */
/*                                                                          */
/* 1985-08-19  Stig Bystr|m                                                 */
/****************************************************************************/

#include <signal.h>
#include <stdio.h>
#include <errno.h>
#include <sgtty.h>
#include <ctype.h>
#undef FIOCLEX
#undef FIONCLEX
#ifndef
#define BUFSIZE 256
#endif

extern char namebuf[15];
extern short xporig[];
extern short yporig[];
extern short xlorig[];
extern short ylorig[];
extern int xsize;
extern int ysize;
extern int winnr;
/*****Cgraphics**************************************************************/
Cgraphics()
{
    char inbuf[BUFSIZE];
    char grbuf[BUFSIZE];
    char *inp,*grp;
    char cha[2];
    char ch;
    int fg,nr,i,d;
    FILE *fh;

    strcpy(inbuf,"./installed/");
    strcpy(grbuf,"./graphics/");

    inp = inbuf + strlen(inbuf);
    grp = grbuf + strlen(grbuf);

    strcpy(inp,namebuf);
    inp=inp+strlen(namebuf);

  /* L{s grafikfilnamn och |ppna filen. */

    fg = open(inbuf, 0);

    if(fg>0){
	ch='a'; /* a dummyv{rde */
	d=2;
	while((ch!=',')&&((d=read(fg,&ch,1))>0));/* L{s f|rbi /icons/filnamn*/
	ch='a'; /* a dummyv{rde */
	d=2;
	while ((ch!=',')&&((d=read(fg,&ch,1))>0)){ /* L{s grafikfilnamn */
	    *grp++=ch;
	}
	*--grp='\0';
        cha[1]='\000'; /*initiering*/

        fh = fopen(grbuf, "r");

	if(fh!=NULL){
	    /* L{s esc-sekvenserna till menu.wd) */
	    while((d=getc(fh))!=EOF){
		if(d=='\033'){
		    sendfill("\\e");
		}
		else{
		    if(isspace(d)==0){/* not space */
		        if(isdigit(d)){/* digit */
			    ch=d-'0';
			    numout(ch);
			}
			else{
       	 	            cha[0]=d;
			    sendfill(cha);
		        }
		    }
		}
	    }
        }
	fclose(fh);
    }
    close(fg);
    send();
    return;
}
/*****slut Cgraphics**********************************************************/

/****************************************************************************/
init()
{
    int i,j;

    sendfill("init:substitute1:menu1");
    sendfill("\n");
    sendfill("#");
    sendfill("\n");
    sendfill("substitute1:init#0:onof#0xfe:mpup#0xa1:mpdo#0xa3");
    sendfill(":mple#0xac:mpri#0xa4:mpul#0xad:\\");
    sendfill("\n");
    sendfill(":mpur#0xa5:mpdl#0xaf:mpdr#0xa7:lpup#0xb1");
    sendfill(":lpdo#0xb3:lple#0xbc:lpri#0xb4:\\");
    sendfill("\n");
    sendfill(":lpul#0xbd:lpur#0xb5:lpdl#0xbf:lpdr#0xb7");
    sendfill(":pcmd#0xcc:cwin#0xce:mtxt#0xcd:\\");
    sendfill("\n");
    sendfill(":step#1:lstp#16");/*step=1 =>1 pixels f|rflyttning med plattan*/
    sendfill("\n");
    sendfill("\n");

    for (i=0;i<36;i++){

	sendfill("icon");
	numout(i+1);
	sendfill(":pxor#");
	numout(xporig[i]);
	sendfill(":pyor#");
	numout(yporig[i]);
	sendfill(":pxsi#");
	numout(xsize);
	sendfill(":pysi#");
	numout(ysize);
	sendfill(":\\");
	sendfill("\n");
	sendfill("     ");

	sendfill(":lxor#");
	numout(xlorig[i]);	
	sendfill(":lyor#");
	numout(ylorig[i]);
	sendfill(":lxsi#");
	numout(xsize);
	sendfill(":lysi#");
	numout(ysize);
	sendfill(":\\");

	sendfill("\n");
	sendfill("     ");
	sendfill(":pmod");
	sendfill(":lmod");
	sendfill(":inve");
	sendfill(":rqst");
	sendfill("\n");
	sendfill("\n");
    } /* end for ... */

    for(i=1;i<=6;i++){   /*skapa 6 f|nster f|r menyer ( window1 - window6 ) */
        winnr++;
	sendfill("window");
	numout(i);
	sendfill(":pxor#");
	numout(0);
	sendfill(":pyor#");
	numout(1024-(i*ysize)-(i-1)-6);
	sendfill(":pxsi#");
	numout(768);/*Hela bredden hos sk{rmen {ven om bara 767pixel anv{nds*/
	sendfill(":pysi#");
	numout((i*ysize)+(i-1)+6);
	sendfill(":pvxo#");
	numout(0);
	sendfill(":pvyo#");
	numout(0);
	sendfill(":pvxs#");
	numout(768);
	sendfill(":pvys#");
	numout((i*ysize)+(i-1)+6);
	sendfill(":\\");
	sendfill("\n");

	sendfill("       :lxor#");
	if(i%2==0)j=(i/2);
	     else j=(i+1)/2;
	numout(1024-(j*xsize)-(j-1)-6);
	sendfill(":lyor#");
	numout(31);
	sendfill(":lxsi#");
	numout((xsize*j)+(j-1)+6);
	sendfill(":lysi#");
	numout(737);
	sendfill(":lvxo#");
	numout(0);
	sendfill(":lvyo#");
	numout(0);
	sendfill(":lvxs#");
	numout((xsize*j)+(j-1)+6);
	sendfill(":lvys#");
	numout(737);
	sendfill(":\\");
	sendfill("\n");

	sendfill("       :bord#0:colr#1:pfnt#0x48:lfnt#0x48:\\");
	sendfill("\n");
	sendfill("       :pmod:lmod:ncur:spec");
	sendfill("\n");
	sendfill("\n");
    }
    return;
}
/****slut init **************************************************************/


/*****ramar******************************************************************/
ramar(antal,pl)
int antal;
char pl;
{
    switch(antal){
      case 6:if(pl=='p'){
	       sendfill("\\e:0;0m\\e:766;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:766;0m\\e:766;65;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:766;65m\\e:0;65;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:0;65m\\e:0;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;2m\\e:764;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:764;2m\\e:764;63;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:764;63m\\e:2;63;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;63m\\e:2;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:129;2m\\e:129;63;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:256;2m\\e:256;63;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:383;2m\\e:383;63;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:510;2m\\e:510;63;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:637;2m\\e:637;63;;1d\\");
	       sendfill("\n");
	     }
	     else{
	       sendfill("\\e:0;0m\\e:131;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:131;0m\\e:131;736;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:131;736m\\e:0;736;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:0;736m\\e:0;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;2m\\e:129;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:129;2m\\e:129;734;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:129;734m\\e:2;734;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;734m\\e:2;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;63m\\e:129;63;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;124m\\e:129;124;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;185m\\e:129;185;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;246m\\e:129;246;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;307m\\e:129;307;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;368m\\e:129;368;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;429m\\e:129;429;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;490m\\e:129;490;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;551m\\e:129;551;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;612m\\e:129;612;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;673m\\e:129;673;;1d\\");
	       sendfill("\n");
	     }
      break;
      case 12:if(pl=='p'){
	       sendfill("\\e:0;0m\\e:766;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:766;0m\\e:766;126;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:766;126m\\e:0;126;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:0;126m\\e:0;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;2m\\e:764;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:764;2m\\e:764;124;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:764;124m\\e:2;124;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;124m\\e:2;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;63m\\e:764;63;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:129;2m\\e:129;124;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:256;2m\\e:256;124;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:383;2m\\e:383;124;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:510;2m\\e:510;124;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:637;2m\\e:637;124;;1d\\");
	       sendfill("\n");
	     }
	     else{
	       sendfill("\\e:0;0m\\e:131;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:131;0m\\e:131;736;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:131;736m\\e:0;736;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:0;736m\\e:0;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;2m\\e:129;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:129;2m\\e:129;734;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:129;734m\\e:2;734;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;734m\\e:2;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;63m\\e:129;63;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;124m\\e:129;124;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;185m\\e:129;185;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;246m\\e:129;246;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;307m\\e:129;307;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;368m\\e:129;368;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;429m\\e:129;429;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;490m\\e:129;490;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;551m\\e:129;551;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;612m\\e:129;612;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;673m\\e:129;673;;1d\\");
	       sendfill("\n");
	     }
	break;
      case 18:if(pl=='p'){
	       sendfill("\\e:0;0m\\e:766;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:766;0m\\e:766;187;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:766;187m\\e:0;187;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:0;187m\\e:0;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;2m\\e:764;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:764;2m\\e:764;185;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:764;185m\\e:2;185;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;185m\\e:2;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;63m\\e:764;63;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;124m\\e:764;124;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:129;2m\\e:129;185;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:256;2m\\e:256;185;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:383;2m\\e:383;185;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:510;2m\\e:510;185;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:637;2m\\e:637;185;;1d\\");
	       sendfill("\n");
	     }
	     else{
	       sendfill("\\e:0;0m\\e:258;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:258;0m\\e:258;736;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:258;736m\\e:0;736;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:0;736m\\e:0;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;2m\\e:256;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:256;2m\\e:256;734;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:256;734m\\e:2;734;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;734m\\e:2;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:129;2m\\e:129;734;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;63m\\e:256;63;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;124m\\e:256;124;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;185m\\e:256;185;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;246m\\e:256;246;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;307m\\e:256;307;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;368m\\e:256;368;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;429m\\e:256;429;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;490m\\e:256;490;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;551m\\e:256;551;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;612m\\e:256;612;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;673m\\e:256;673;;1d\\");
	       sendfill("\n");
	     }
	break;
      case 24:if(pl=='p'){
	       sendfill("\\e:0;0m\\e:766;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:766;0m\\e:766;248;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:766;248m\\e:0;248;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:0;248m\\e:0;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;2m\\e:764;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:764;2m\\e:764;246;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:764;246m\\e:2;246;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;246m\\e:2;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;63m\\e:764;63;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;124m\\e:764;124;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;185m\\e:764;185;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:129;2m\\e:129;246;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:256;2m\\e:256;246;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:383;2m\\e:383;246;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:510;2m\\e:510;246;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:637;2m\\e:637;246;;1d\\");
	       sendfill("\n");
	     }
	     else{
	       sendfill("\\e:0;0m\\e:258;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:258;0m\\e:258;736;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:258;736m\\e:0;736;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:0;736m\\e:0;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;2m\\e:256;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:256;2m\\e:256;734;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:256;734m\\e:2;734;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;734m\\e:2;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:129;2m\\e:129;734;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;63m\\e:256;63;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;124m\\e:256;124;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;185m\\e:256;185;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;246m\\e:256;246;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;307m\\e:256;307;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;368m\\e:256;368;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;429m\\e:256;429;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;490m\\e:256;490;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;551m\\e:256;551;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;612m\\e:256;612;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;673m\\e:256;673;;1d\\");
	       sendfill("\n");
	     }
	break;
      case 30:if(pl=='p'){
	       sendfill("\\e:0;0m\\e:766;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:766;0m\\e:766;309;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:766;309m\\e:0;309;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:0;309m\\e:0;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;2m\\e:764;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:764;2m\\e:764;307;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:764;307m\\e:2;307;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;307m\\e:2;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;63m\\e:764;63;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;124m\\e:764;124;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;185m\\e:764;185;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;246m\\e:764;246;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:129;2m\\e:129;307;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:256;2m\\e:256;307;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:383;2m\\e:383;307;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:510;2m\\e:510;307;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:637;2m\\e:637;307;;1d\\");
	       sendfill("\n");
	     }
	     else{
	       sendfill("\\e:0;0m\\e:385;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:385;0m\\e:385;736;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:385;736m\\e:0;736;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:0;736m\\e:0;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;2m\\e:383;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:383;2m\\e:383;734;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:383;734m\\e:2;734;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;734m\\e:2;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:129;2m\\e:129;734;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:256;2m\\e:256;734;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;63m\\e:383;63;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;124m\\e:383;124;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;185m\\e:383;185;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;246m\\e:383;246;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;307m\\e:383;307;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;368m\\e:383;368;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;429m\\e:383;429;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;490m\\e:383;490;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;551m\\e:383;551;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;612m\\e:383;612;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;673m\\e:383;673;;1d\\");
	       sendfill("\n");
	     }
	break;
      case 36:if(pl=='p'){
	       sendfill("\\e:0;0m\\e:766;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:766;0m\\e:766;370;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:766;370m\\e:0;370;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:0;370m\\e:0;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;2m\\e:764;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:764;2m\\e:764;368;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:764;368m\\e:2;368;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;368m\\e:2;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;63m\\e:764;63;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;124m\\e:764;124;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;185m\\e:764;185;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;246m\\e:764;246;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;307m\\e:764;307;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:129;2m\\e:129;368;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:256;2m\\e:256;368;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:383;2m\\e:383;368;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:510;2m\\e:510;368;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:637;2m\\e:637;368;;1d\\");
	       sendfill("\n");
	     }
	     else{
	       sendfill("\\e:0;0m\\e:385;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:385;0m\\e:385;736;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:385;736m\\e:0;736;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:0;736m\\e:0;0;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;2m\\e:383;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:383;2m\\e:383;734;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:383;734m\\e:2;734;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;734m\\e:2;2;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:129;2m\\e:129;734;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:256;2m\\e:256;734;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;63m\\e:383;63;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;124m\\e:383;124;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;185m\\e:383;185;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;246m\\e:383;246;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;307m\\e:383;307;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;368m\\e:383;368;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;429m\\e:383;429;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;490m\\e:383;490;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;551m\\e:383;551;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;612m\\e:383;612;;1d\\");
	       sendfill("\n");
	       sendfill("\\e:2;673m\\e:383;673;;1d\\");
	       sendfill("\n");
	     }
	break;

    } /*end switch*/
    return;
}
/*******slut ramar***********************************************************/

/****************************************************************************/
/* end of igr.c                                                             */
/****************************************************************************/
